<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <title>React Tutorial</title>
    <!-- Not present in the tutorial. Just for basic styling. -->
    <link rel="stylesheet" href="css/base.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/react/15.1.0/react.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/react/15.1.0/react-dom.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.6.16/browser.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/2.2.2/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/remarkable/1.6.2/remarkable.min.js"></script>
  </head>
  <body>
    <div id="content"></div>
    <!--<script type="text/babel" src="scripts/example.js"></script>-->
    <script type="text/babel">
      var data = [
        { id: 1, author: "Eze", text: "This is one comment" },
        { id: 2, author: "Dorian", text: "This is _another_ comment" },
        { id: 3, author: "Chris", text: "I <3 CF, CFUN" },
      ];

      var CommentBox = React.createClass({
        loadCommentsFromServer: function() {
          $.ajax({
            url: this.props.url,
            dataType: 'json',
            cache: false,
            success: function(data) {
              this.setState({ data: data });
            }.bind(this),
            error: function(xhr, status, err) {
              console.error(this.props.url, status, err.toString());
            }.bind(this)
          });
        },

        handleCommentSubmit: function(comment) {
          var comments = this.state.data;
          // otimistically set an id on the new comment. It will be replaced by
          // an id generated by the server. In a production application you would
          // likely not use Date.now() for this an would have a more robust system
          // in place.
          comment.id = Date.now();
          var newComments = comments.concat([comment]);
          this.setState({ data: newComments });
          $.ajax({
            url: this.props.url,
            dataType: 'json',
            type: 'POST',
            data: comment,
            success: function(data) {
              this.setState({ data: data });
            }.bind(this),
            error: function(xhr, status, err) {
              this.setState({ data: comments });
              console.error(this.props.url, status, err.toString());
            }.bind(this)
          });
        },

        getInitialState: function() {
          return { data: [] };
        },

        componentDidMount: function() {
          this.loadCommentsFromServer();
          setInterval(this.loadCommentsFromServer, this.props.pollInterval);
        },

        render: function() {
          return (
            <div className="commentBox">
              <h1>Comments</h1>
              <CommentList data={ this.state.data } />
              <CommentForm onCommentSubmit={ this.handleCommentSubmit } />
            </div>
          );
        }
      });

      var CommentList = React.createClass({
        render: function() {
          // map takes the values of the array 'data' and applies the function
          // to convert the json data into comments React elements, then returns
          // an array of comments React elements
          var commentNodes = this.props.data.map(function(comment) {
            return(
              <Comment author={ comment.author } key={ comment.id }>
                { comment.text }
              </Comment>
            )
          });
          // In the list element all that we have to-do is to include the array
          // of comment React elements and they will be displayed accordingly
          return(
            <div className="commentList">
              { commentNodes }
            </div>
          );
        }
      });

      var CommentForm = React.createClass({
        getInitialState: function() {
          return { author: '', text: '' };
        },

        handleAuthorChange: function(e) {
          this.setState({ author: e.target.value });
        },

        handleTextChange: function(e) {
          this.setState({ text: e.target.value });
        },

        handleSubmit: function(e) {
          e.preventDefault();
          var author = this.state.author.trim();
          var text = this.state.text.trim();
          if (!text || !author) {
            return;
          }
          this.props.onCommentSubmit({ author: author, text: text });
          this.setState({ author: '', text: '' });
        },

        render: function() {
          return(
            <form className="commentForm" onSubmit={ this.handleSubmit }>
              <input 
                type="text"
                placeholder="Your Name"
                value={ this.state.author }
                onChange={ this.handleAuthorChange }
              />
              <input 
                type="text"
                placeholder="Say something..."
                value={ this.state.text }
                onChange={ this.handleTextChange }
              />
              <input type="submit" value="Post" />
            </form>
          );
        }
      });

      var Comment = React.createClass({
        rawMarkup: function() {
          var md = new Remarkable();
          var rawMarkup = md.render(this.props.children.toString());
          return { __html: rawMarkup };
        },

        render: function() {
          var md = new Remarkable();
          return(
            <div className="comment">
              <h2 className="commentAuthor">
                { this.props.author }
              </h2>
              <span dangerouslySetInnerHTML={ this.rawMarkup() } />
            </div>
          );
        }
      });

      ReactDOM.render(
        <CommentBox url="/api/comments" pollInterval={ 2000 } />,
        document.getElementById('content')
      );
    </script>
  </body>
</html>
